#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>

// This C file is used to develop and debug the highly detailed C functions.
// It contains some of the original samples and testing tools
// It is not expected to compile because it is adapted each time it is needed
// for whatever function is being tested.
// and if later changes are made in Dev-C++, this code goes out of date
//
// Compiles in Borland C++ 3.1 DOS

#ifndef NELEM
#define NELEM(xyzzy) (sizeof(xyzzy)/sizeof(xyzzy[0]))
#endif

#ifdef PLAT_WIN
#define NPPWINDOWS 1
#else
#define NPPWINDOWS 0
#endif
#define NPPDEBUG 1 /* set to 1 to turn on a couple of checkers */

#pragma warn -rch /* Borland-C warning: unreachable code */
#pragma warn -ccc /* Borland-C warning: condition is always true/false */

#define HWND int
struct NppData {
  HWND _nppHandle;
  HWND _scintillaMainHandle;
  HWND _scintillaSecondHandle;
} nppData;
#define PLUGIN_NAME "TextFX (debug)"
#define MB_OK 0
#define MB_ICONSTOP 0
#define MB_ICONWARNING 0

#pragma warn -par /* Borland-C warning: parameter is never used */
void MessageBox(int owner,char *msg,char *title,int action) {
  printf("%s: %s\n",title,msg);
}
#pragma warn +par /* Borland-C warning: parameter is never used */

#if NPPDEBUG
void * _pascal memmovetest(void *dest,void *src,size_t n) {
  size_t m;
  m=strlen(src);
  if (m+1 != n) {
#if NPPWINDOWS
    char debug[512]; sprintf(debug,"memmovetest wrong SLN strlen(+1):%u != SLN:%u",strlen(src)+1,n); MessageBox(nppData._nppHandle , debug,PLUGIN_NAME, MB_OK);
#else /* Borland C for DOS */
     printf("Wrong SLN:%u != strlen(+1):%d\n",n,m+1);
#endif
     n=m;
  }
  return(memmove(dest,src,n));
}
#else
#define memmovetest memmove
#endif

#define GetSLNValue(GSVroutine)\
  sln=0;\
  if (strsln) sln=*strsln;\
  if (!sln) {\
    sln=strlen(str);\
    if (strsln) *strsln=sln;\
  } else if (NPPDEBUG && sln!=strlen(str)) {\
    if (NPPWINDOWS) MessageBox(nppData._nppHandle , GSVroutine ": bad length value",PLUGIN_NAME, MB_OK);\
    else printf(GSVroutine ": bad length value strlen():%u != strsln:%u\n",strlen(str),*strsln);\
    if (fail) *fail=str;\
    sln=strlen(str);\
    if (strsln) *strsln=sln;\
  }

// GetD_SLNValues is always called after GetSLNValue since it uses sln
#define GetD_SLNValues(routine,GSVdvar)\
  if (stopeol) {\
    GSVdvar = *stopeol;\
    if (NPPDEBUG && GSVdvar && (GSVdvar<str || GSVdvar>str+sln)) {\
      if (NPPWINDOWS) MessageBox(nppData._nppHandle , routine ": bad d value",PLUGIN_NAME, MB_OK|MB_ICONSTOP);\
      else printf(routine ": bad d value");\
    }\
    if (!GSVdvar || GSVdvar<str || GSVdvar>str+sln) GSVdvar=str;\
    sln-=GSVdvar-str;\
  } else GSVdvar=str;

#define vsnprintf vsprintf /* you'll need to rem out the bufsize manually */

// insert functions to test here

/* snprintfX() attempts to perfectly duplicate what sprintf() does
   without the unsafeness of sprintf() or the bugs and problems of snprintf()
   snprintfX(buf,sizeof(buf),"format string",...);
   Unlike the official snprintf():
     * snprintfX() writes no more than sizeof(buf)-1 non null characters plus a guaranteed \0 ending.
     * snprintfX() always returns the exact number of characters written not including the \0 ending
     * snprintfX() does not return a -1 if an error occurs or more buffer space is needed
     * snprintfX() does not return the total number bytes that would be
       needed to store the entire string when there is not enough space
   If you need any of that functionality, you must call the real functions as smprintf() does */
size_t snprintfX(char *buffer,size_t len,const char *format,...) {
#if !NPPWINDOWS /* Borland-C-DOS does not have snprintf() so we do the best we can */
  char temp[4096];
#endif
  size_t rv=0;
  va_list ap;
  if (buffer && len) {
    va_start(ap, format);
    buffer[0]='\0';
#if !NPPWINDOWS
    if (len>=sizeof(temp)) {
      rv=vsprintf(buffer,format,ap);
    } else {
      rv=vsprintf(temp,format,ap);
      strncpy(buffer,temp,rv>=len?len:rv);
    }
#else
    rv=vsnprintf(buffer,len,format,ap);
#endif
    buffer[len-1]='\0';
    if (rv==(unsigned)-1) rv=strlen(buffer);
    if (rv>=len) rv=len-1;
    va_end(ap);
  }
  return(rv);
}

/* snprintf() falls short of the mark.
   What we really need is smprintf(...) AKA mprintf(...).
   Like strdup() it malloc()'s sufficient space and places the sprintf()
   results in it. The caller will get the entire result without needing to
   overguess and waste space.
   http://libslack.org/manpages/snprintf.3.html
   smprintf() handles the broken vsnprintf() implementations that return -1 when there isn't enough space.
   smprintf() guarantees that there is a \0 on the end */
char *smprintf(const char *format,...) {
  char *rv;
  va_list ap;
  size_t len,vs;
  va_start(ap, format);
  for(len=8 /* initial buffer size */, rv=(char *)malloc(len/*+100*/); len && rv && !(rv[len-1]='\0') && ((vs=vsnprintf(rv,/*len-1,*/format,ap))>len-1 || rv[len-1]); free(rv),rv=(char *)malloc(len)) {
#ifdef __WATCOMC__ /* apparently you can't use the va_list over and over in Watcom-C */
  	va_end(ap);
  	va_start(ap, format);
  	vs++; /* when the buffer is too short, Watcom-C returns the entire required buffer length including the \0 byte, +1 from everyone else's library */
#endif
#if defined(__MINGW32__) || defined(_MSC_VER) || defined(__DMC__) /* bugged library returns -1 not enough buffer space */
  	if (vs == (unsigned)-1) len *=2; else
#endif
  	len=vs+1; /* if snprintf() ever returned -1 for any other reason, len would become 0 which would cause a halt */
#if NPPWINDOWS /* no recursive calls please */
    //char debug[256]; snprintfX(debug,sizeof(debug),"vsnprintf() returns %u; Trying length %u",vs,len); MessageBox(nppData._nppHandle,debug,PLUGIN_NAME, MB_OK|MB_ICONSTOP);
#endif
  }
  va_end(ap);
#if NPPDEBUG
  if (vs != strlen(rv)) { /* no recursive calls please */
    char debug[256]; snprintfX(debug,sizeof(debug),"vs=%u strlen(rv)=%u",vs,strlen(rv)); MessageBox(nppData._nppHandle,debug,PLUGIN_NAME, MB_OK|MB_ICONSTOP);
    vs = strlen(rv);
  }
#endif
  if (rv && vs+1<len) {
    rv=(char *)realloc(rv,vs+1);
#if NPPWINDOWS /* no recursive calls please */
    //char debug[256]; snprintfX(debug,sizeof(debug),"Final length (including \\0) was %u",vs+1); MessageBox(nppData._nppHandle,debug,PLUGIN_NAME, MB_OK|MB_ICONSTOP);
#endif
  }
  //if (rv) puts(rv);
  return(rv);
}

/* snprintf() falls short of the mark. What we really need is smprintf(...).
   Like strdup() it malloc()'s sufficient space and places the sprintf()
   results in it. The caller will get the entire result without needing to
   overguess and waste space. */
/* Since a real smprintf() is quite difficult, I'll just implement a basic
   ...sprintf() subset that will cover for most cases! */
/* Control characters:
   Supported: exactly as shown; no modifiers allowed!
     %%=%
     %c=character
     %s=string
     %d,%i=integer
     %o=octal
     %u=unsigned
     %x,%X hex
   New and Improved Functionality:
     %?_, optional character _ immediately after ? is only inserted if the previous character is not a _
     %C, optional character next in va_args is only inserted if the previous character is not the same
       special note: if the character is a space then it is only inserted if the previous character is not whitespace
   Not Supported:
     Any internal modifiers
     float types
   Example: strdupcat("%c%?:%s%?\\%s%?\\%s",'C',"\\WINDOWS\","TEMP","TEMPFILE.TXT") produces
     C:\WINDOWS\TEMP\TEMPFILE.TXT
*/
char *smprintfpath(char *format,...) {
  size_t tlen=1,llen;
  char *argst,*rv,*dest,*cx,lastch,checkch,cmd[3],tempspace[128];
  unsigned pass,argu;
  for(pass=0; pass<2; pass++) {
    va_list ap;
    va_start(ap, format);
    for(lastch='\0',cx=format; *cx; cx++) {
      if (*cx!='%') {
        lastch=*cx;
        goto dochar;
      } else switch(*++cx) {
      case '\0': cx--; break; /* feed the \0 back to kill the for loop */
      case '%': lastch  = '%'; goto dochar;
      case 'c': lastch  = (int)va_arg(ap,unsigned); goto dochar;
      case 'C': checkch = (int)va_arg(ap,unsigned); goto checkchar;
      case '?':
        cx++;
        checkch=*cx;
checkchar:
        if (!(checkch==' ' && isspace(lastch) || lastch==checkch)) {
          lastch=checkch;
dochar: if (!pass) {
            tlen++;
          } else {
            *dest=lastch;
            dest++;
            *dest='\0';
          }
        }
        break;
      case 'd':
      case 'i':
      case 'o':
      case 'u':
      case 'x':
      case 'X':
        argu = va_arg(ap,unsigned);
        strcpy(cmd,"%c");
        cmd[1]=*cx;
        //snprintf(tempspace,sizeof(tempspace),cmd,argu);
        sprintf(tempspace,cmd,argu); /* without any modifiers this can't be very long */
        argst=tempspace;
        goto dostring;  /* this saves code but wastes a strlen on a known short string */
      case 's':
        argst = va_arg(ap,char *);
dostring:
        if (!pass) {
          if (llen=strlen(argst)) {
            lastch=argst[llen-1];
            tlen+=llen;
          }
        } else {
          while(*dest=*argst) {dest++; argst++;} // stpcpy() isn't always available
          if (dest>rv) lastch=*(dest-1);
        }
        break;
      }
    }
    va_end(ap);
    if (!pass) {
      if (!(dest=rv=(char *)malloc(tlen))) break;
    }
  }
  //printf(rv);
  return(rv);
}

/* case insenstive strstr() */
// new feature: detect non case sensitive search string and call strstr() instead
char *stristr(char *str,char *search,unsigned sln) {
  char *d,*dp,fch[3];
  unsigned lold,chn;
  int same;

  if (lold=strlen(search)) {
    for(d=search; *d; d++) if (tolower(*d)!=toupper(*d)) goto stristryes;
    return(lold==1?strchr(str,*search):strstr(str,search));
stristryes:
    fch[0]=tolower(*search);
    fch[1]=toupper(*search);
    fch[2]='\0';
    same=(fch[0]==fch[1]);
    d=str;
    goto bottest; do {
      d+=chn;
      sln-=chn;
      if (!strnicmp(d,search,lold)) return(d);
      d++;
      chn--;
bottest:
      if (same) {
        if (!(dp=strchr(d,*search))) break;
        chn=dp-d;
      } else {
        chn=strcspn(d,fch);
      }
    } while(chn<sln);
  }
  return(NULL);
}

// the search will be faster if like first characters are placed together
// the search will be faster if sizeof(_MSTR) is a power of two
struct _MSTR {
// eventually, mstr[0] will be eliminated completely.
  char string[27]; // nocase=0: 1+the number of different search first characters
                   // nocase=1: 1+the number of different search first characters with an extra for characters who's case differs
  unsigned char nocase; // Each search is individually case sensitive. The entire table is handled case insensitive until we are iterating through possible matches then pick it out case sensitive if requested.
  char rv;
  unsigned char len; // filled in by the initializer
  // proposed features for faster string searching
  unsigned char lennext; // how many characters are common between the current string and the next string
  unsigned char lenskip; // We can skip lenskip+1 forward if string[lennext-1] does not match. currentpos+lenskip+1 is permitted to exceed NELEM. If !lenskip perform a memcmp()
  //unsigned char minlength; // the smallest length in the lenskip+1 to be skipped. This enables bsearch() to locate the nearest starting location using characters up to the smallest length
} mstring[]={
{""                  ,0,0 ,0,0,0}, // mstring[0] is where the search string is stored from call to call
{"\t"                ,0,7 ,0,0,0}, // set case insensitive strings to 0 for better efficiency
{"\n"                ,0,8 ,0,0,0},
{"\r"                ,0,8 ,0,0,0},
{" "                 ,0,7 ,0,0,0},
{"&#"                ,0,0 ,0,0,0},
{"&AMP;\0&"          ,1,1 ,0,0,0}, 
{"&COPY;\0(C)"       ,1,1 ,0,0,0},
{"&GT;\0>"           ,1,1 ,0,0,0},
{"&lT;\0<"           ,1,1 ,0,0,0},
{"&NBSP;\0 "         ,1,1 ,0,0,0},
{"&quot;\0\""        ,1,1 ,0,0,0},
{"<!--\0-->"         ,0,2 ,0,0,0},
{"</CAPTION"         ,1,3 ,0,0,0},
{"</H"               ,1,3 ,0,0,0},
{"</LI"              ,1,3 ,0,0,0},
{"</PRE"             ,1,6 ,0,0,0},
{"</P"               ,1,3 ,0,0,0},
{"</TEXTAREA"        ,1,6 ,0,0,0},
{"</TITLE"           ,1,3 ,0,0,0},
{"</TR"              ,1,3 ,0,0,0},
{"<BR"               ,1,3 ,0,0,0},
{"<HR"               ,1,3 ,0,0,0},
{"<PRE"              ,1,5 ,0,0,0},
{"<P"                ,1,3 ,0,0,0},
{"<STYLE\0</STYLE>"  ,1,2 ,0,0,0},
{"<SCRIPT\0</SCRIPT>",1,2 ,0,0,0},
{"<TD"               ,1,4 ,0,0,0},
{"<TEXTAREA"         ,1,5 ,0,0,0},
{"<TH"               ,1,4 ,0,0,0},
{"<\0>"              ,0,2 ,0,0,0},
};                  

//int mstrnocase=0;
//char *mstrxst=NULL; // if ax or bx is NULL, compare the non null with mstrxst

int fcmpmstrsort(const void *ax,const void *bx) {
  int acu,bcu,dif;
#if 0 /* Each time I try to use bsearch() I fail because of differing string lengths */
  struct _MSTR *am=ax;
  struct _MSTR *bm=bx;
  //unsigned const char *ac,*bc;
  if (mstrnocase) {
    dif=toupper(am->string[0])-toupper(bm->string[0]);
  } else {
    dif=am->string[0]-bm->string[0];
  }
  if (dif) return(dif);
  dif=bm->len-am->len;
  if (dif) return(dif);
  return(stricmp(am->string,bm->string));
  //        return(stricmp(((struct _MSTR *)ax)->string,((struct _MSTR *)bx)->string));
#else
  char *ac,*bc;
  for(ac=((struct _MSTR *)ax)->string,bc=((struct _MSTR *)bx)->string; 1; ac++, bc++) {
    //if (mstrnocase) {
      acu=toupper(*ac);
      bcu=toupper(*bc);
    /*} else {
      acu=*ac;
      bcu=*bc;
    }*/
    if (acu == bcu) {
      if (!acu) return(0);
    } else if (!bcu) return(-1); // the longer string is always sorted first
    else if (!acu) return(1); // the shorter string is always sorted last
    else return(acu - bcu);
  }
#endif
}

#if 0
int fcmpmstrbsearch(const void *ax,const void *bx) {
//struct _MSTR *axm=ax;struct _MSTR *bxm=bx;
  char *ac,*bc;
  int acu,bcu;
  if (ax && bx) { // in Borland-C, ax is always the key
    MessageBox(nppData._nppHandle , "Impossible",PLUGIN_NAME, MB_OK|MB_ICONWARNING);
    exit(1);
  }
  ac=mstrxst;
  bc=ax?(((struct _MSTR *)ax)->string):(((struct _MSTR *)bx)->string);
  while(1) {
    if (mstrnocase) {
      acu=toupper(*ac);
      bcu=toupper(*bc);
    } else {
      acu=*ac;
      bcu=*bc;
    }
    if (acu == bcu) {
      if (!acu) return(0);
    } else if (!bcu) return(0); // they are considered equal if the right string ends
    //else if (!acu) return(-1);
    //#error If we are at the largest of a run of equals, forward, else subtract
    else return(bx?(acu-bcu):(bcu-acu));
    ac++;
    bc++;
  }
}
#endif

#if NPPDEBUG
// check to see if a number is a power of two
int powcheck(unsigned num) {
  unsigned test=1;

  if (!num) return(0); /* I've decided that 0 is not a power of two */
  do {
    if (num==test) return(1);
    test <<=1;
  } while(test);
  return(0);
}
#endif

// returns the number of initial characters that are equal
size_t streqct(char *t1,char *t2) {
  size_t rv=0;
  while(*t1 && *t1==*t2) {rv++; t1++; t2++; }
  return(rv);
}

// compute the skip values in the mstring array
void strmstrinit(struct _MSTR *msearch,unsigned nsearch,unsigned *cs/*,int nocase*/) {
  unsigned ch,chn;
  unsigned i,dn,up,lsearch;
#if NPPDEBUG
    if (!powcheck(sizeof(struct _MSTR)))
      MessageBox(nppData._nppHandle , "struct _MSTR size is not a power of two",PLUGIN_NAME, MB_OK|MB_ICONWARNING);
#endif
    //mstrnocase=nocase;
    for(i=1; i<nsearch; i++) {msearch[i].len=strlen(msearch[i].string); msearch[i].lenskip=0;}
    qsort(msearch+1,nsearch-1,sizeof(*msearch),fcmpmstrsort);
    for(i=2; i<nsearch; i++) msearch[i-1].lennext=streqct(msearch[i-1].string,msearch[i].string);
    for(i=1; i<nsearch; i++) {
      if ((chn=msearch[i].lennext) && !(msearch[i].lenskip)) {
        for(dn=1; dn<256 && dn+i<nsearch && msearch[dn+i].lennext>=chn; dn++);
        for(up=dn; up!=(unsigned)-1; up--) if (msearch[i+up].lennext==chn) msearch[i+up].lenskip=dn-up;
      }
    }
    //for(i=1; i<nsearch; i++) printf("{\"%24s\",%3d,%3d,%3u,%3u,%3u},\n",msearch[i].string,msearch[i].nocase,msearch[i].rv,msearch[i].rv,msearch[i].len,msearch[i].lennext,msearch[i].lenskip);
    for(i=0; i<256; i++) {cs[i]=(unsigned)-1; cs[i+256]=0; }
    memset(msearch,0,sizeof(msearch[0]));
    for(lsearch=0, i=1; i<nsearch && lsearch<sizeof(msearch[0].string); i++) {
      ch=(unsigned)msearch[i].string[0];
      if (/*nocase && */(tolower(ch)!=toupper(ch))) {
        if (cs[tolower(ch)]>i) cs[tolower(ch)]=i;
        if (cs[tolower(ch)+256]<i) cs[tolower(ch)+256]=i;
        if (cs[toupper(ch)]>i) cs[toupper(ch)]=i;
        if (cs[toupper(ch)+256]<i) cs[toupper(ch)+256]=i;
      } else {
        if (cs[ch]>i) cs[ch]=i;
        if (cs[ch+256]<i) cs[ch+256]=i;
      }
      if (msearch[i].len && !strchr(msearch[0].string,ch)) {
        msearch[0].string[lsearch++]=toupper(ch);
        if (/*nocase &&*/ tolower(ch)!=toupper(ch)) msearch[0].string[lsearch++]=tolower(ch);
      }
    }
    msearch[0].len=lsearch;
}

// When mstring search gets more advanced the close function will need to clean some stuff up.
#define strmstrclose(mstr)

// Try #1: if (stristr()) {} else if (strstr()) {} else if (stristr())...
// Try #2: Iterate through sorted table from quick[ch] to quick[ch+256] to find a match
// Try #3: "Boyer-Moore Prefix Vector Skip Table" because smaller prefixes have greater skip potential
// Purpose: Search through a long non delimited string for the
// largest possible (greedy) of multiple case sensitive or insensitive substrings.
//
// There is a lot of good theory on multiple substring search which someone better than I may
// be able to implement.
// Returns: 0,p=NULL if not found, or mstring position 1...nsearch-1,p=location if found
//
// We could eliminate sln by padding the string with as many \0 as the longest substring
// This would eliminate the necessity of string scan to calculte strlen().
// The trouble is that the caller has to manage and possibly move the padded \0's and this may
// be more trouble than the REPNZ SCASB that calculates strlen(). Often times
// the caller already needs strlen() for something else so has it readily available.

// new feature: Implement bsearch() and minlength through lenskip to reduce iteration
// new feature: Allow for active use with deletestring, deletestringmultiple, insertstring and insertstringmultiple with autorecalc using insert sorts or recalc entire array
// new feature: When strings are pointers, shiftstrings will change the pointer values in case the caller has to realloc() the memory and the base pointer changes
char *strmstr(char *str,unsigned sln,unsigned *mno,struct _MSTR *msearch/*,unsigned nsearch*/,unsigned *cs/*,int nocase*/) {
  unsigned i,slnt;
  char *d;
  struct _MSTR *im;

  if (str && *str) {
    d=str;
    goto bottest; do {
      for(slnt=sln-(d-str),i=cs[*(unsigned char *)d],im=msearch+i; i<=cs[*(unsigned char *)d+256]; /*i++,im+=sizeof(*msearch)*/) {
        if (slnt<im->len) {
            i++; im++; // no space left for string
#if 1
        } else if (im->lennext && toupper(im->string[im->lennext-1])!=toupper(d[im->lennext-1])) { // non match at largest position, skip all possible
          i += im->lenskip+1;
          im = msearch+i; // this is the easiest way to do the multiplication
#endif
        } else if (!(im->nocase?memicmp(d,im->string,im->len):memcmp(d,im->string,im->len))) { // iterate through the possible matches checking case if requested
          *mno=i; // someday when the iteration counts get too long, we will use bsearch() with the newly created minlength to find the iteration starting point
          return(d);
        } else {
          i++; im++;
        }
      }
      d++;
bottest:
      if (msearch[0].len==1) {
        if (!(d=strchr(d,msearch[0].string[0]))) break;
      } else {
        d += strcspn(d,msearch[0].string); // eventually the complementary string will be so long that quick[] will be the only easy way to find the next candidate character
      }
    } while(*d);
  }
  *mno=0;
  return(NULL);
}

// the editor can double certain line breaks during a paste, this code can't fix it.
// when > is used as data like ">", this code doesn't catch it, and I may not fix it because it is improper HTML
unsigned stripHTMLtags(char *str,unsigned *strsln,const char *snotabs,unsigned *maxexpand,char **fail) {
//#define ncase 1
  unsigned n=0,sln,lold,lnew,mno;
  char *d,*dp,*newst,*lastspace,*lastnewline,tempst[2],space[]=" ",tab[]="\t";
  unsigned intextarea;
  int notabs=(*snotabs=='n');
  unsigned quick[512];

  if (!fail || !*fail) { // other routines should be modified to do this also
    GetSLNValue("stripHTMLtags")
    strmstrinit(mstring,NELEM(mstring),quick/*,ncase*/);
    for(d=str,lastspace=str,lastnewline=str,intextarea=0; dp=strmstr(d,sln,&mno,mstring/*,NELEM(mstring)*/,quick/*,ncase*/); ) {
      sln -= (dp-d);
      d = dp;
      switch(mstring[mno].rv) {
      case 0: // & general
        dp=strchr(d,';');
        if (!d || dp-d>8 || !isdigit(d[2]) || (int)(lnew=strtol(d+2,NULL,0))<0 || lnew>255) {
          d++;
          sln--;
          continue;
        } else {
          lold=dp-d+1;
          newst=tempst;
          newst[0]=lnew;
          newst[1]='\0';
          lnew=1;
        }
        break;
      case 1: // &quot;
        lold=mstring[mno].len;
        newst=mstring[mno].string+lold+1;
        lnew=strlen(newst);
        break;
      case 2: // <!-- stuff to delete -->
        lold=strlen(mstring[mno].string+mstring[mno].len+1);
        dp=stristr(d,mstring[mno].string+mstring[mno].len+1,sln);
        lnew=0;
        goto delcom;
      case 3: // <tag that generates newline
        newst="\r\n";
        lnew=strlen(newst);
        lastspace=d+lnew;
        lastnewline=d+lnew;
        goto bktcom;
      case 4: // <tag that generates tab
        newst=notabs?space:tab;
        lnew=1;
        goto bktcom;
      case 5: // <tag that indicates we are entering a preformatted section
        intextarea++;
        lnew=0;
        goto bktcom;
      case 6: // <tag that indicates we are leaving a preformatted section
        if (intextarea) intextarea--;
        lnew=0;
bktcom:
        lold=1;
        dp=strchr(d,'>');
delcom:
        if (dp) {
          lold+=dp-d;
        } else {
          d+=sln;
          sln=0;
          continue;
        }
        break;
      case 7: // space without return
      case 8: // return
        lold=strspn(d,"\r\n\t ");
        if (intextarea) {
          d+=lold;
          sln-=lold;
          continue;
        }
        if (d<=lastspace || d<=lastnewline/* || mstring[mno].rv==8*/) {
          lnew=0;
        } else {
          newst=" ";
          lnew=1;
          lastspace=d+1;
        }
        if (mstring[mno].rv==8) lastnewline=d;
        break;
      }
      if (lnew != lold) {
        if (maxexpand) {
          if (lnew>lold && lnew-lold>*maxexpand) {
            if (fail) *fail = d;
            goto failbreak;
          }
          *maxexpand -= lnew-lold;
        }
        memmovetest(d+lnew,d+lold,sln-lold+1);
        sln += lnew-lold;
        if (strsln) *strsln+=lnew-lold;
      }
      if (lnew) {
        memcpy(d,newst,lnew);
        d+=lnew;
        sln-=lnew;
      }
      n++;
    }
failbreak:
    strmstrclose(mstring);
  }
  return(n);
//#undef ncase
}

// Search through a string for quote symbols
// If starting at a non quote, will return the postion of the next quote
// If starting at a quote, will return the position after the close quote
// If at end of string, returns NULL
// style=0, detect c-string escaping \" or \' or \\ or \anycharacter
// style=1, detect vb-string escaping "" or sql escaping ''
// style=2, Foxpro-string: no escaping
// some routines use 0 for no string detection and style-1 for the styles
char * findnextquote(char *str,unsigned style) {
  unsigned chn,dx;
  char *nq,cq[3];

  if (!*str) return(NULL);
  if (*str=='"' || *str=='\'') {
    strcpy(cq,style?"'":"'\\");
    cq[0]=str[0];
    str++;
    dx=1;
  } else {
    strcpy(cq,"'\"");
    dx=0;
  }
  while(1) {
    chn=strcspn(str,cq);
    str+=chn;
    if (!*str) return(str);
    if (!style) { // C
      if (*str!='\\') return(str+dx);
      str+=str[1]?2:1;
    } else { // VB & Foxpro
      if (style==1 && str[0]==str[1]) str+=2;
      else return(str+dx);
    }
  }
}

// This removes all non quoted text from str. The quoted text segments that remain are separated by newst
// style is defined by findnextquote()
unsigned findqtstringsca(char *str,unsigned *strsln,const char *newst,unsigned style,unsigned *maxexpand,char **fail) {
  unsigned n=0,sln,lold,lnew;
  char *d,*dp,chtemp;
  unsigned flags;

  if (!fail || !*fail) {
    GetSLNValue("findqtstringsca")
    for(dp=str; d=findnextquote(dp,style); dp=d) {
      switch(*dp) {
      case '"' :
      case '\'':
        lold=0;
        lnew=strlen(newst);
        break;
      default:
        lold=d-dp;
        lnew=0;
        d=dp;
        break;
      }
      if (lnew != lold) {
        if (maxexpand) {
          if (lnew>lold && lnew-lold>*maxexpand) {
            if (fail) *fail = d;
            goto failbreak;
          }
          *maxexpand -= lnew-lold;
        }
        memmovetest(d+lnew,d+lold,sln-(d-str)-lold+1);
        sln += lnew-lold;
      }
      if (lnew) {
        memcpy(d,newst,lnew);
        d+=lnew;
      }
      n++;
    }
failbreak:
    if (strsln) *strsln=sln;
  }
  return(n);
}

static char *spc=NULL; // spc should be free() at the program end if not NULL
static unsigned spclen=0;
char *replicate(unsigned n,char ch) {
  if (!n || !ch) return("");
  if (spclen<n || !spc) {
    if (spc) free(spc);
    if (!(spc=(char *)malloc(n+1))) {
      spclen=0;
      return("");
    }
    spc[0]='\0';
    spclen=n;
  }
  if (spc[0]!=ch) {
    memset(spc,ch,spclen);
    spc[spclen]='\0';
  }
  return(spc+spclen-n);
}

// returns the number of changes made
unsigned mymemset(char *s,char c,unsigned num){
  unsigned n=0;
  for(; num; num--, s++) {
    if (*s != c) {
      *s=c;
      n++;
    }
  }
  return(n);
}

// usetabs=1: convert leading spaces to tabs
// usetabs=0: convert leading tabs to spaces
// preserveodd: non multiples of tabwidth spacing will be preserved, otherwise truncated (amending might overflow the buffer if we amend a lot of spaces)
unsigned space2tabsca(char *str,unsigned *strsln,int usetabs,unsigned tabwidth,int preserveodd,unsigned *maxexpand,char **fail) {
  unsigned n=0,sln,lnew,lold,spacect,indent;
  char *d,*dp;

  if (!fail || !*fail) {
    GetSLNValue("spaces2tabs")
    for(d=str; *d; ) {
      for(indent=0,dp=d; 1; dp++) {
        if (*dp==' ') indent++;
        else if (*dp=='\t') indent+=tabwidth;
        else break;
      }
      lold=(dp-d);
      if (usetabs) {
        lnew=indent/tabwidth;
        if (preserveodd && lnew*tabwidth!=indent) lnew=lold=0;
      } else lnew=indent;
          if (lnew != lold) {
            if (maxexpand) {
              if (lnew>lold && lnew-lold>*maxexpand) {
                if (fail) *fail = d;
                goto failbreak;
              }
              *maxexpand -= lnew-lold;
            }
            memmovetest(d+lnew,d+lold,sln-(d-str)-lold+1);
            sln += lnew-lold;
            n++;
          }
          if (lnew) {
            if (mymemset(d,usetabs?'\t':' ',lnew) && lnew==lold) n++;
            d+=lnew;
          }
      d+=strcspn(d,"\r\n");
      d+=strspn(d,"\r\n");
    }
failbreak:
    if (strsln) *strsln=sln;
  }
  return(n);
}

/* C++ ruins the speed and reliability of this project. AStyle was a C++ wrapper on poor C code. */
/* AStyle also doesn't indent the way I like it. */
/* This does not handle certain if-else because it is too hard to detect a single statement:
  if (cond)
     stmt;
  else
     stmt;*/
unsigned c_astyle2(char *str,unsigned *strsln,int usetabs,unsigned tabwidth,unsigned *maxexpand,char **fail) {
  unsigned n=0,sln,bktct,lold,lnew,parenct,tempindent;
  char *d,*dp,*label;
  if (!fail || !*fail) {
    n+=space2tabsca(str,strsln,1,tabwidth,0,maxexpand,fail);
    GetSLNValue("c_astyle2")
    for(tempindent=parenct=0,bktct=strspn(str,"\t"),dp=d=str; *dp; ) {
      if (*dp=='i' && dp[1]=='f' && (dp[2]==' ' && dp[3]=='(' || dp[2]=='(')) {
        dp+=2;
        dp+=(*dp==' ')?2:1;
        parenct=1;
      } else if (*dp=='/' && dp[1]=='/') { // C++ comment
        dp+=strcspn(dp,"\r\n"); // this does not handle \ comment continuations which shouldn't be used anways
      } else if (*dp=='/' && dp[1]=='*') { /* C comment */
        dp=strstr(dp+2,"*/");
        if (!dp) dp=str+sln;
        else dp+=2;
      } else if (*dp=='"' || *dp=='\'') {
        dp = findnextquote(dp,0);
      } else if (*dp=='\r' || *dp=='\n') {
        if (*(dp-1)=='\\' && (*d=='#' || tempindent)) tempindent=2;
        dp+=(*dp=='\r' && dp[1]=='\n')?2:1;
        for(d=dp; *dp=='\t'; dp++);
        lold=dp-d;
        lnew=bktct+parenct+(parenct?1:0)+(tempindent>1?1:0); // indent conditionals separated by lines
        if (*dp!=':') for (label=dp; *label; label++) {
          if (*label==':') {
            if (label[1]==':') label=NULL; // C++ class::function
            break;
          }
          if (!isalnum(*label)) {
            label=NULL;
            break;  
          }// label will be non NULL if we hit the end of file with nothing but alpha: but this will be so rare that it's not worth catching
        } else label=NULL; 
        if (/*{*/*dp=='}' || !memcmp(dp,"case ",5) || !memcmp(dp,"default:",8) || !memcmp(dp,"public:",7) || !memcmp(dp,"private:",8) || !memcmp(dp,"protected:",10)) {
          if (lnew) lnew--;
        } else if (!*dp || *d=='#' || *d=='\r' || *d=='\n' || label) lnew=0;
        if (lnew != lold) {
          if (maxexpand) {
            if (lnew>lold && lnew-lold>*maxexpand) {
              if (fail) *fail = d;
              goto failbreak;
            }
            *maxexpand -= lnew-lold;
          }
          memmovetest(d+lnew,d+lold,sln-(d-str)-lold+1);
          sln += lnew-lold;
          n++;
        }
        if (lnew) {
          if (mymemset(d,'\t',lnew) && lnew==lold) n++;
          d+=lnew;
        }
        dp=d;
        if (tempindent) tempindent--;
      } else {
        if (parenct && *dp=='(') parenct++;
        else if (parenct && *dp==')') parenct--;
        else if (*dp=='{') bktct++;
        else if (*dp=='}') bktct--; 
        dp++;
      }
    }
failbreak:
    if (strsln) *strsln=sln;
    if (!usetabs) n+=space2tabsca(str,strsln,usetabs,tabwidth,0,maxexpand,fail);
  }
  return(n);
}

#pragma warn -par /* Borland-C warning: parameter is never used */

int main(int argc,char *argv[]) {
  char sts[]=
/*"AAA</tr></tr><b>&#36;2005-08-29</b><br>Test\nTest2<br>\n T\n"
"<img src=\"gfx/o.gif\" width=9 height=9 alt=\"o\"> A new utilities for <b>KMK/JZ.</b> hdd interface: <a href=\"http://drac030.krap.pl/fdisk2.arc\">FDISK II 2.1</a> (<b>update!</b>),<a href=\"http://drac030.krap.pl/kmkdiag.arc\">KMK/JZ Diag 1.1</a> and <a href=\"http://drac030.krap.pl/hdbios19.arc\">IDE Bios 1.9</a>. More info on <a href=\"http://drac030.atari8.info\">Draco's site</a> in download section.</p>\n"
" t <html> \n\n\n<tag> Depech&pizza;&nbsp;Mode<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n"
"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n"
"  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n"
"  <html xmlns=\"http://www.w3.org/1999/xhtml\">\n"
"<head>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\"></meta>\n"
"<style type=\"text/css\" media=\"screen\">\n"
"  body,table,input {\n"
"    font-family: verdana, arial, helvetica, geneva, swiss, sunsans-regular, sans-serif;\n"
"    font-size: 10pt;\n"
"  }\n"
"</style>\n"
"<title>TopDog Pet&nbsp;Care Online&copy;&Gt;&lt;&quot;</title>\n"
"</head>\n"
"<!--#include file=\"style.htm\"-->hello Captain & Tenneile"*/
/*    "NPPTextFX"
    "NPPTextFX,  a GPL \n\n \n\n Plugin for Notepad++ by Chris Severance and other authors.\t"
    "Perform a variety of conversions on selected text. \r\n\r\n\r\n"
    "If\tthere is\nnot enough\tmemory to complete,\ttext still needing changes will be left marked.\n"
    "Some menu choices will show help if no text is selected or the Selection is empty\r\n\r\n \r\n\r\n"*/
//    "printf(\"String1\");<var>;\n\"quo'ted\\\"str'ing2\"\0;variable;'\r\nstring\"3\"'\"juxtastring\")" // c-string
/*  "*str=='\\'') {\n"
  "  strcpy(cq,style?\"'\\\\\":\"'\");\n"
  "  strcpy(cq,\"'\\\"\");\n"
  "    if (*str!='\\\\') return(str+dx);\n"*/
/*    "FILL DOWN TEXT\n"
    "case 'c': num=strtol(str,NULL,0); break;\n"
    "case 'd': num=strtol(str,NULL,10); break;\n"
    "LN TOO SHRT\n\n"
    "case 'h': num=strtol(str,NULL,16); break;\n"
    "case 'b': num=strtol(str,NULL,2); break;\n"
    "case 'o': num=strtol(str,NULL,8); break; \n\n\n\n\n\n"*/
//    "\"Here\\l\"\"ies\\'ethyl\\\",\"\\gone\\\"\n"
//    "2.6 4.7 65.61 8\n-10000 +.09"
/*    "case 9: strcpy(str,\"T,B\"); strcpy(lit,\"\\\\t\"); break;\n"
    "case 10: strcpy(str,\"LF\"); strcpy(lit,\"\\\\n\"); break;\n"
    "case '\\\"': strcpy(lit,\"\\\\\\\"\"); break;\n"*/
//  "\n\nAA\r\n  A\n\n    a\n  AAAA\n"
//    "\t    \n \t hello\n"
//     "test  \ntest 2\ntest 3    "
  "#define XXX\\\nxyzzy\\\npdq\nvoid (test) {\r\n/* test\n\ttest 2*/\nif ((a) || // \"\r\n(b) ) {\n\t\tprintf('t\'{est');\r\n\t}\r\n}\n"
;
  char st[10000];
  unsigned maxexpand;
  char *fail=NULL,*res;
  //unsigned nm[512]
  unsigned rv,sln;
  char in[16];
  int i=0;

  clrscr();
    printf("\nStart:\n");
    strcpy(st,sts);
    sln=strlen(st);
    maxexpand=sizeof(st)-sln-1;

#if 1 /* 0=process all, 1=process line by line */
  /*for(i=8; i<255 && !fail; i++) {
    sprintf(in,"%d",i);
    strcpy(st,sts);
    sln=strlen(st);
    maxexpand=sizeof(st)-sln-1;
    rewraptextcatest(st,&sln,0,0,&maxexpand,&fail);
  }
  if (!fail) {
    rv=rewraptextcatest(st,&sln,0,0,&maxexpand,&fail);
    printf("Done %d\n",rv);
#if NPPDEBUG
    printout(st,"\n");
    printf("All OK up to %d!",i);
#else
    printf("All OK up to %d!\n%s",i,st);
#endif
  }*/

  //rv=strtran(st,&sln,NULL,NULL,"'","\\\"",&maxexpand,&fail);
  //rv=stripHTMLtags(st,&sln,"n",&maxexpand,&fail);
  //rv=strmstr(st,&res,mstring,NELEM(mstring),&nm,1); printf("Done %d\n%s\n",rv,res);
  //rv=findqtstringsca(st,&sln,",",1,&maxexpand,&fail);
  //rv=strchrstrans(st,&sln,NULL,"&<>\"",",&&amp;,<&lt;,>&gt;,\"&quot;,",&maxexpand,&fail);
  //rv=prepostpend(st,&sln,0,"echo \"","\\n\";","\\\"",";\\\\\\;\"\\\";",&maxexpand,&fail);
  //rv=insertselectioncolumnca(st,&sln,"$$M$soft",0,&maxexpand,&fail); //"$-8$#16+10"
  //rv=0; strcpy(st,""); printf("%u-%d %u-%d %u-%d %u-%d %u-%d\n",56,powcheck(56),32,powcheck(32),1,powcheck(1),0,powcheck(0),32768u,powcheck(32768u));
  //rv=filldownca(st,&sln,0,&maxexpand,&fail);
  //rv=addup(st);
  //rv=lineup(st,&sln,',',1,8,1,&maxexpand,&fail);
  //rv=space2tabsca(st,&sln,0,2,0,&maxexpand,&fail);
  //rv=strqsortlines(st,&sln,1,4,&maxexpand,&fail);
  //rv=indenttextca(st,&sln,0,2,&maxexpand,&fail);
  //rv=trimtrailingspaceca(st,&sln,&maxexpand,&fail);
  //rv=c_astyle2(st,&sln,0,2,&maxexpand,&fail);
  //res=smprintfX("%u%?7%xC%C%?:%s%?\\%s%?\\%s",65,128,'C',"\\WINDOWS\\","TEMP","TEMPFILE.TXT",NULL);
  //res=smprintf("%c%d%f",'x',59,33.26);
  printf("sprintf()=%d\n%s\n",sprintf(st,"%","test"),st);
  snprintfX(st,10+0*sizeof(st),"%c%d%f",'x',59,33.26);
#else
  for(i=1,rv=0,res=st; *res && !fail; i++) {
    printf("\nLine %d ",i);
    //sln=0; //sln+=7;
    rv+=strchrstrans(st,&sln,&res,"\r\n&<>\"",",&&amp;,<&lt;,>&gt;,\"&quot;,",&maxexpand,&fail);
    //rv+=strtran(st,&sln,&res,"\"","\\\"",&maxexpand,&fail);
    while(*res=='\r' || *res=='\n') res++;
  }
#endif
    printf("Done(%d-%s) %d\n%s\n",i,fail?"Fail":"Success",rv,st);
    if (strlen(st)!=sln) printf("strsln not calculated properly strlen():%u != strsln:%u\n",strlen(st),sln);
    if (strlen(st)+maxexpand+1!=sizeof(st)) printf("maxexpand not properly calculated strlen()+max+1:%u != sizeof:%u\n",strlen(st)+maxexpand+1,sizeof(st));
    /*if (spc) {
      free(spc);
      spc=NULL;
      spclen=0;
    }*/
  return(0);
}
